<template>
<!--
    props:
      dataSocial -> the name of the social ['facebook','twitter','linkedin','youtube','instagram','mail']
      dataIsShare -> (bool) set if the button is a share button or a link (the share is only for facebook, linkedin and twitter)
      dataHref -> url for external page
      dataTarget -> (_blank default) set where to open the link
      dataRel-> set the rel
      dataTitleShare ->  title of the share
      dataSubjectMail (only for mail) -> subject of the mail
      dataShareUrl -> url of the share
    -->
  <!-- 
      1. Ho convertito l'option api in composition api
      2. Utilizzato la function custom useCastToPropType al posto del mixin cms-support
     -->
  <a
    class="WaSocialShareItem"
    :href="getUrl"
    :target="dataTarget !== '' ? dataTarget : null"
    :rel="dataRel !== '' ? dataRel : null"
    @click="onButtonClick"
  >
    <svg 
      width="24" 
      height="24" 
      :class="['socialIcon', dataSocial ]"
    >
      <use 
      :href="`#icon-social-${dataSocial}`" 
      fill="currentColor" 
      />
    </svg>
    <js-loader
      v-if="dataSocial==='pinterest'"
      :data-async="true"
      :data-defer="true"
      data-id="pinterest-initializer"
      data-src="//assets.pinterest.com/js/pinit.js"
    />
    <!--
      buttonPin if you are using a “one Pin” button, or
      buttonBookmark if you are using an “any Pin” button
  -->
  </a>
</template>
<script>
import JsLoader from "../components/js-loader.vue";
import { computed } from "vue";
import useCastPropToType from "../hooks/useCastPropToType.js";
export default {
  name: "WaSocialShareItem",
  components: { JsLoader },
  props: {
    dataSocial: {
      type: String,
      default: ''
    },
    dataIsShare: {
      type: [Boolean,String],
      default: false
    },
    dataHref: {
      type: String,
      default: ''
    },
    dataTarget: {
      type: String,
      default: '_blank'
    },
    dataRel: {
      type: String,
      default: ''
    },
    dataTitleShare: {
      type: String,
      default: ''
    },
    dataSubjectMail: {
      type: String,
      default: ''
    },
    dataShareUrl: {
      type: String,
      default: ''
    }
  },
  setup(props) {
    const twitterShareUrl = computed(() => {
      return `https://twitter.com/intent/tweet?url=${encodeURI(
        props.dataShareUrl
      )}`;
    });
    const fbShareUrl = computed(() => {
      return `https://www.facebook.com/sharer/sharer.php?u=${encodeURI(
        props.dataShareUrl
      )}`;
    });
    const linkedinShareUrl = computed(() => {
      return `https://www.linkedin.com/shareArticle?mini=true&url=${encodeURI(
        props.dataShareUrl
      )}&title=${encodeURIComponent(props.dataTitleShare)}&source=LinkedIn`;
    });
    const mailUrl = computed(() => {
      return `mailto:?subject=${props.dataTitleShare}&body=${encodeURIComponent(
        props.dataTitleShare
      )} ${encodeURI(props.dataShareUrl)}`;
    });

    const isShare = computed(() => {
      return useCastPropToType(props.dataIsShare, "boolean");
    });

    const getUrl = computed(() => {
      if (isShare.value) {
        if (props.dataSocial === 'twitter') {
          return twitterShareUrl.value;
        } else if (props.dataSocial === 'facebook') {
          return fbShareUrl.value;
        } else if (props.dataSocial === 'linkedin') {
          return linkedinShareUrl.value;
        } else if (props.dataSocial === 'mail') {
          return mailUrl.value;
        } else {
          return '#';
        }
      } else {
        return props.dataHref;
      }
    });

    function openPopup(event) {
      popupCenter(event.currentTarget.href, props.dataTitleShare, 580, 470);
    }

    function popupCenter(url, title, w, h) {
      // Fixes dual-screen position                         Most browsers      Firefox
      var dualScreenLeft = window.screenLeft !== undefined ? window.screenLeft : screen.left;
      var dualScreenTop = window.screenTop !== undefined ? window.screenTop : screen.top;

      var width = window.innerWidth ? window.innerWidth : document.documentElement.clientWidth ? document.documentElement.clientWidth : screen.width;
      var height = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight ? document.documentElement.clientHeight : screen.height;

      var left = ((width / 2) - (w / 2)) + dualScreenLeft;
      var top = ((height / 3) - (h / 3)) + dualScreenTop;

      var newWindow = window.open(url, title, 'scrollbars=yes, width=' + w + ', height=' + h + ', top=' + top + ', left=' + left);

      // Puts focus on the newWindow
      if (newWindow && newWindow.focus) {
        newWindow.focus();
      }
    }
    function onButtonClick(event) {
      if (isShare.value && props.dataSocial !== 'mail') {
        event.preventDefault();
        if (props.dataSocial === 'pinterest') {
          window.PinUtils.pinAny();
        } else {
          openPopup(event);
        }
      }
    }

    return {
      getUrl,
      onButtonClick
    };
  }
};
</script>
<style lang="scss">
@import "@/scss/_variables";

.WaSocialShareItem {
  display: flex;
  width: 45px;
  height: 45px;
  align-items: center;
  justify-content: flex-start;
  color:inherit;
}

.socialIcon {
  display: block;
}
</style>